BOOTCTL(1)

NAME
bootctl - Control the firmware and boot manager settings

SYNOPSIS

bootctl [OPTIONS...] {COMMAND}

DESCRIPTION

bootctl can check the EFI boot loader status, list available boot loaders and boot loader entries, and install, update, or remove the systemd-boot(7) boot loader on the current system.

COMMANDS

status
    Shows brief information about the system firmware, the boot loader that was used to boot the system, the boot loaders currently available in the ESP, the boot loaders listed in the firmware's list of boot loaders and the current default boot loader entry. If no command is specified, this is the implied default.

install
    Installs systemd-boot into the EFI system partition. A copy of systemd-boot will be stored as the EFI default/fallback loader at ESP/EFI/BOOT/BOOT*.EFI. The boot loader is then added to the top of the firmware's boot loader list.

update
    Updates all installed versions of systemd-boot(7), if the available version is newer than the version installed in the EFI system partition. This also includes the EFI default/fallback loader at ESP/EFI/BOOT/BOOT*.EFI. The boot loader is then added to end of the firmware's boot loader list if missing.

remove
    Removes all installed versions of systemd-boot from the EFI system partition and the firmware's boot loader list.

is-installed
    Checks whether systemd-boot is installed in the ESP. Note that a single ESP might host multiple boot loaders; this hence checks whether systemd-boot is one (of possibly many) installed boot loaders — and neither whether it is the default nor whether it is registered in any EFI variables.

random-seed
    Generates a random seed and stores it in the EFI System Partition, for use by the systemd-boot boot loader. Also, generates a random 'system token' and stores it persistently as an EFI variable, if one has not been set before. If the boot loader finds the random seed in the ESP and the system token in the EFI variable it will derive a random seed to pass to the OS and a new seed to store in the ESP from the combination of both. The random seed passed to the OS is credited to the kernel's entropy pool by the system manager during early boot, and permits userspace to boot up with an entropy pool fully initialized very early on. Also see systemd-boot-system-token.service(8).

    See Random Seeds[1] for further information.

systemd-efi-options [VALUE]
    When called without the optional argument, prints the current value of the "SystemdOptions" EFI variable. When called with an argument, sets the variable to that value. See systemd(1) for the meaning of that variable.

list
    Shows all available boot loader entries implementing the Boot Loader Specification[2], as well as any other entries discovered or automatically generated by the boot loader.

set-default ID, set-oneshot ID
    Sets the default boot loader entry. Takes a single boot loader entry ID string as argument. The set-oneshot command will set the default entry only for the next boot, the set-default will set it persistently for all future boots.

OPTIONS

The following options are understood:

--esp-path=
    Path to the EFI System Partition (ESP). If not specified, /efi/, /boot/, and /boot/efi/ are checked in turn. It is recommended to mount the ESP to /efi/, if possible.

--boot-path=
    Path to the Extended Boot Loader partition, as defined in the Boot Loader Specification[2]. If not specified, /boot/ is checked. It is recommended to mount the Extended Boot Loader partition to /boot/, if possible.

-p, --print-esp-path
    This option modifies the behaviour of status. Only prints the path to the EFI System Partition (ESP) to standard output and exits.

-x, --print-boot-path
    This option modifies the behaviour of status. Only prints the path to the Extended Boot Loader partition if it exists, and the path to the ESP otherwise to standard output and exit. This command is useful to determine where to place boot loader entries, as they are preferably placed in the Extended Boot Loader partition if it exists and in the ESP otherwise.

    Boot Loader Specification Type #1 entries should generally be placed in the directory "$(bootctl -x)/loader/entries/". Existence of that directory may also be used as indication that boot loader entry support is available on the system. Similarly, Boot Loader Specification Type #2 entries should be placed in the directory "$(bootctl -x)/EFI/Linux/".

    Note that this option (similar to the --print-booth-path option mentioned above), is available independently from the boot loader used, i.e. also without systemd-boot being installed.

--no-variables
    Do not touch the firmware's boot loader list stored in EFI variables.

--graceful
    Ignore failure when the EFI System Partition cannot be found, or when EFI variables cannot be written. Currently only applies to random seed operations.

--no-pager
    Do not pipe output into a pager.

-h, --help
    Print a short help text and exit.

--version
    Print a short version string and exit.

EXIT STATUS

On success, 0 is returned, a non-zero failure code otherwise.

ENVIRONMENT

If $SYSTEMD_RELAX_ESP_CHECKS=1 is set the validation checks for the ESP are relaxed, and the path specified with --esp-path= may refer to any kind of file system on any kind of partition.

Similarly, $SYSTEMD_RELAX_XBOOTLDR_CHECKS=1 turns off some validation checks for the Extended Boot Loader partition.

SEE ALSO

systemd-boot(7), Boot Loader Specification[2], Boot Loader Interface[3], systemd-boot-system-token.service(8)

NOTES

1.  Random Seeds
    https://systemd.io/RANDOM_SEEDS

2.  Boot Loader Specification
    https://systemd.io/BOOT_LOADER_SPECIFICATION

3.  Boot Loader Interface
    https://systemd.io/BOOT_LOADER_INTERFACE